package be.iminds.ilabt.jfed.lowlevel;

import javax.annotation.Nonnull;
import javax.annotation.Nullable;

/**
 * GeniUserProvider returns the logged in GeniUser.
 * <p>
 * When the user hasn't authenticated yet, the method getLoggedInGeniUser() will return null.
 */
public interface GeniUserProvider {
    class NoUserLoggedInException extends RuntimeException{
        public NoUserLoggedInException() { }
        public NoUserLoggedInException(String s) { super(s); }
        public NoUserLoggedInException(String s, Throwable throwable) { super(s, throwable); }
        public NoUserLoggedInException(Throwable throwable) { super(throwable); }
        public NoUserLoggedInException(String s, Throwable throwable, boolean b, boolean b1) { super(s, throwable, b, b1); }
    }

    /**
     * Info on main user.
     * If no user logged in, throw a NoUserLoggedInException
     */
    @Nonnull GeniUser getLoggedInGeniUser() throws NoUserLoggedInException;

    boolean isUserLoggedIn();
}
